#! /usr/bin/env python
import rospy
from geometry_msgs.msg import Twist
from sensor_msgs.msg import Joy

# This ROS Node converts Joystick inputs from the joy node

def callback(data):
    twist = Twist()
    twist.linear.x = 1*data.axes[5]     # right joystick up/down [full up 1, full down -1]
    twist.linear.y = 1*data.axes[2]     # right joystick right/left [full right -1, full left 1]
    twist.angular.z = 1*data.axes[0]    # left joystick right/left [full right -1, full left 1]
    pub.publish(twist)

# Intializes everything
def start():
   
    # starts the node
    rospy.init_node('joy_controller')
    rospy.loginfo("Joy Controller node started")
    rospy.loginfo("Subscribing /joy and publishing /cmd_vel topics")

    global pub
    pub = rospy.Publisher('/cmd_vel', Twist, queue_size=10)

    # subscribed to joystick inputs on topic "joy"
    rospy.Subscriber("joy", Joy, callback)

    rospy.spin()

if __name__ == '__main__':
    start()